/*	This program is released under European Union Public License.
 *  for details please refer to the file LICENSE
 *   
 *  Disclaimer: the program comes "as is" and with absolutely no warranty 
 *  
 *  © 2010 TCM
 */

package gui.filechooser;

import java.nio.file.DirectoryStream.Filter;
import java.nio.file.Path;

public class FilesChooserFilter {
	private Filter<Path> filter;
	private String displayName,ext;
	
	public FilesChooserFilter(Filter<Path> filter,String displayName) {
		this(filter, displayName, null);
	}
	
	public FilesChooserFilter(Filter<Path> filter,String displayName,String extension) {
		this.filter=filter;
		this.displayName=displayName;
		this.ext=extension;
	}
	
	public Filter<Path> getFilter() {
		return filter;
	}
	
	public String getDisplayName() {
		return displayName;
	}

	public static FilesChooserFilter get(String displayName,final String extension) {
		return new FilesChooserFilter(new Filter<Path>() {
			
			@Override
			public boolean accept(Path f) {
				return f.getFileName().toString().endsWith(extension);
			}
		}, displayName,extension);
	}

	public String getExtension() {
		return ext;
	}
	
}
