package gui.layout.percent2;


public class APConstraint {
	private int left, right, top, bottom, width, height;
//	private int leftOffset,topOffset,widthOffset,heightOffset;
	private boolean percentLeft, percentRight, percentTop, percentBottom, percentWidth, percentHeight;

	private APConstraint() {
		left=-1;
		right=-1;
		top=-1;
		bottom=-1;
		width=-1;
		height=-1;
	}
	
	public static APConstraint linearV(int heightP,int topP) {
		return new APConstraint().left(0).right(0).topPercent(topP).heightPercent(heightP);
	}
	
	public static APConstraint constraint() {
		return new APConstraint();
	}

	public APConstraint left(int left) {
		this.left = left;
		return this;
	}

	public APConstraint right(int right) {
		this.right = right;
		return this;
	}

	public APConstraint bottom(int bottom) {
		this.bottom = bottom;
		return this;
	}

	public APConstraint height(int height) {
		this.height = height;
		return this;
	}

	public APConstraint bottomPercent(int bottom) {
		this.percentBottom = true;
		return bottom(bottom);
	}

	public APConstraint heightPercent(int height) {
		this.percentHeight = true;
		return height(height);
	}

	public APConstraint leftPercent(int left) {
		this.percentLeft = true;
		return left(left);
	}

	public APConstraint rightPercent(int right) {
		this.percentRight = true;
		return right(right);
	}

	public APConstraint topPercent(int top) {
		this.percentTop = true;
		return top(top);
	}

	public APConstraint widthPercent(int width) {
		this.percentWidth = true;
		return width(width);
	}
	
	/*public APConstraint widthOffset(int widthOffset) {
		this.widthOffset = widthOffset;
		return this;
	}
	
	public APConstraint leftOffset(int leftOffset) {
		this.leftOffset = leftOffset;
		return this;
	}
	
	public APConstraint heightOffset(int heightOffset) {
		this.heightOffset = heightOffset;
		return this;
	}
	
	public APConstraint topOffset(int topOffset) {
		this.topOffset = topOffset;
		return this;
	}*/

	public APConstraint top(int top) {
		this.top = top;
		return this;
	}

	public APConstraint width(int width) {
		this.width = width;
		return this;
	}
	
	int getBottom(int targetHeight) {
		if (percentBottom)
			return targetHeight*bottom/100;
		else
			return bottom;
	}
	
	int getHeight(int targetHeight) {
		if (percentHeight)
			return targetHeight*height/100;
		else
			return height;
	}
	
	int getLeft(int targetWidth) {
		if (percentLeft)
			return targetWidth*left/100;
		else
			return left;
	}
	
	int getRight(int targetWidth) {
		if (percentRight)
			return targetWidth*right/100;
		else
			return right;
	}
	
	int getTop(int targetHeight) {
		if (percentTop)
			return targetHeight*top/100;
		else
			return top;
	}
	
	int getWidth(int targetWidth) {
		if (percentWidth)
			return targetWidth*width/100;
		else
			return width;
	}

	/*int getWidthOffset() {
		return widthOffset;
	}
	
	int getHeightOffset() {
		return heightOffset;
	}
	
	int getLeftOffset() {
		return leftOffset;
	}
	
	int getTopOffset() {
		return topOffset;
	}*/
		
	boolean left() {
		return left>-1;
	}
	
	boolean right() {
		return right>-1;
	}
	
	boolean top() {
		return top>-1;
	}
	
	boolean bottom() {
		return bottom>-1;
	}
	
	boolean width() {
		return width>-1;
	}
	
	boolean height() {
		return height>-1;
	}
}
