/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package model.transfer;

import java.io.IOException;

import net.util.Proxy;

import util.exception.CancelException;

public abstract class TransferEngine {
	
	protected TransferInfo info;
	protected static Proxy proxy;
	protected static int timeout;
	protected EngineConfig cfg;
	
	public TransferEngine(TransferInfo info,EngineConfig cfg) {
		this.info=info;
		this.cfg=cfg;
	}
	
	public EngineConfig getCfg() {
		return cfg;
	}
	
	public TransferInfo getTransferInfo() {
		return info;
	}
	
	public static void setProxy(Proxy proxy) {
		TransferEngine.proxy=proxy;
	}
	
	public static void setTimeout(int sec) {
		timeout=sec;
	}
	
	public static Proxy getProxy() {
		return proxy;
	}
	
	public abstract void updateCurrentBytes();

	public abstract void startTransfer() throws IOException, CancelException  ;

	public abstract void cancel();
}
