package scheduler;

import java.util.Collection;


public interface IScheduler {

	void start();

	int addTaskStopped(SchedulerRunnable2 t);

	int addTask(SchedulerRunnable2 t);

	void stopAll();

	SchedulerRunnable2 remove(int id);

	void removeAll();

	SchedulerRunnable2 stop(int id);

	boolean isRunning();

	Collection<SchedulerRunnable2> getActive();

	Collection<SchedulerRunnable2> getUnfinished();

	boolean isRunning(int id);

	SchedulerRunnable2 enqueueStopped(int id);

	void enqueueAllStopped();

	SchedulerRunnable2 getStoppedById(int id);

	Collection<SchedulerRunnable2> getStopped();

//	void reEnqueue(int id);

}