package settings;

import java.nio.file.Path;
import java.util.Locale;
import java.util.Observer;
import java.util.Set;

public interface Settings {

	void fireSettingsChanged(String name);

	void set(String name, String value);
	void set(String name, double value);
	void set(String name, int value);

	void set(String name, Locale l);

	void set(String name, String[] values);

	void set(String name, int[] values);

	void set(String name, boolean value);

	void set(String name, Path value);

	String getString(String name);

	int[] getIntArray(String name);

	String[] getStringArray(String name);

	Integer getInt(String name);

	boolean getBoolean(String name);

	Double getDouble(String name);

	Locale getLocale(String name);

	Set<String> getSettingsKeyset();

	String toString(String name);
	
	Path getPath(String name);

	void addObserver(Observer o);
}