/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package shoshone.httpclient;

public class Cookie {
	private String name,value;
	
	public Cookie(String arg) {
		String s[] =arg.split("; ");
		String t[]=s[0].split("=");
		name=t[0];
		if (t.length>1) {
			value=t[1];
		} else {
			value="";
		}
	}
	
	public Cookie(String name,String value) {
		if (name==null || value==null) throw new IllegalArgumentException();
		
		this.name=name;
		this.value=value;
	}
	
	public String getName() {
		return name;
	}
	
	public String getValue() {
		return value;
	}
	
	public void setValue(String value) {
		if (value==null) throw new IllegalArgumentException();
		
		this.value = value;
	}
	
	@Override
	public String toString() {
		return name+'='+value;
	}
	
	@Override
	public int hashCode() {
		return name.hashCode()+value.hashCode();
	}
	
	@Override
	public boolean equals(Object o) {
		if (o instanceof Cookie) {
			Cookie c=(Cookie)o;
			//System.out.println(c.getName() + " " +name + " " +c.getValue()+ " "+ value);
			return c.getName().equals(name); //&& c.getValue().equals(value);
		} else {
			return false;
		}
	}
	
	@Override
	public Object clone() {
		return new Cookie(name, value);
	}
}
